[LeetCode]Word Ladder 最短距离字符串转换 (Dijkstra)

要求最短距离。采纳dijkstra查找节点之间的最短路径。

当心:假设是一个枚举字典22是否元素可以,如果转换,暂停。

提高:每串,带您历数它的字符值事件,对于的长度n一个字符串枚举n*26次要。

设仅仅是简单的枚举,则会出现重边:

如abc,bbc,cbc,建图后每两个节点间均有两条双向边,这对于邻接表存储的图会存在非常多冗余边。

解决方法:每一个节点每位字符仅仅能从原始字符往后枚举,即

枚举各字符串第一位的话

abc:bbc,cbc,dbc,...

bbc:cbc,dbc,...

cbc:dbc,....

struct Edge{
    int v,next;
};
class Solution {
public:
	Edge*e;
    int *head,len,n;
    void addedge(int u,int v){
        e[len].v=v;
        e[len].next=head[u];
        head[u]=len++;
        e[len].v=u;
        e[len].next=head[v];
        head[v]=len++;
    }
    bool canTrans(const string& p,const string&q){
        int i,cnt=0;
        for(i=0;i<p.size();++i){
            if(p[i]!=q[i]){
                cnt++;
                if(cnt>1)return 0;
            }
        }
        return 1;
    }
    int dijk(int st,int ed){
        int* dist=new int[n],i,v,j,k;
        memset(dist,127,sizeof(int)*n);
		int unre=dist[0];
        for(i=head[st];i!=-1;i=e[i].next){
            v=e[i].v;
            dist[v]=1;
        }
        dist[st]=-1;
        for(j=1;j<n;++j){
            for(i=0,k=-1;i<n;++i)
                if(dist[i]>0&&dist[i]!=unre&&(k<0||dist[i]<dist[k]))
                    k=i;
            if(k<0||k==ed)break;
            for(i=head[k];i!=-1;i=e[i].next){
                v=e[i].v;
                if(dist[v]>=0&&dist[v]>dist[k]+1)
                    dist[v]=dist[k]+1;
            }
            dist[k]=-1;
        }
        if(k==ed)
            k=dist[k];
        else k=-1;
        delete[]dist;
        return k;
    }
    int ladderLength(string start, string end, unordered_set<string> &dict) {
        if(start==end)return 2;
        map<string,int>mp;
        int cnt=0,i;
        mp[start]=cnt++;
        mp[end]=cnt++;
        unordered_set<string>::iterator bg=dict.begin(),ed=dict.end(),bg2;
        for(;bg!=ed;bg++){
            if(mp.find(*bg)==mp.end())
                mp[*bg]=cnt++;
        }
        dict.insert(start);
        dict.insert(end);
		n=dict.size();
        e=new Edge[n*n];
        head=new int[n];
		len=0;
		memset(head,-1,sizeof(int)*n);
		int ch,j;
        for(bg=dict.begin(),ed=dict.end();bg!=ed;bg++){
            string s=*bg;
            for(i=0;i<s.length();++i){
                ch=s[i]-'a';
                for(j=ch+1;j<26;++j){
                    s[i]='a'+j;
                    if(dict.find(s)!=dict.end())
                        addedge(mp[s],mp[*bg]);
                }
                s[i]='a'+ch;
            }
     /*       for(bg2=bg,bg2++;bg2!=ed;bg2++){
                if(canTrans(*bg,*bg2)){
                    addedge(mp[*bg],mp[*bg2]);
                }
            }*/
        }
        i=dijk(mp[start],mp[end]);
		delete[] e;
		delete[]head;
        return i>=0?i+1:0;
    }
};

版权声明:本文博客原创文章,博客,未经同意,不得转载。

时间: 2024-10-02 08:33:19

[LeetCode]Word Ladder 最短距离字符串转换 (Dijkstra)的相关文章

[leetcode]Word Ladder II @ Python

[leetcode]Word Ladder II @ Python 原题地址:http://oj.leetcode.com/problems/word-ladder-ii/ 参考文献:http://blog.csdn.net/doc_sgl/article/details/13341405   http://chaoren.is-programmer.com/ 题意:给定start单词,end单词,以及一个dict字典.要求找出start到end的所有最短路径,路径上的每个单词都要出现在dict

LeetCode &quot;Word Ladder&quot; - TRICKY

It is not as easy as I thought it to be, mostly because of time\space limitation. And actually that's the punch line of this problem My intuition was DFS. I got several failing attemption - all TLE or MLE. Since what we are supposed to find is 'short

[LeetCode]Word Ladder 字符串的最短转换距离 (Dijkstra)

要求最短距离.采用dijkstra求节点间最短路径. 注意点:如果是枚举字典中两两元素是否可转换的话,会超时. 改进:对于每个字符串,枚举其各位字符的取值情况,则对于长度为n的一个字符串要枚举n*26次. 如果只是简单的枚举,则会出现重边: 如abc,bbc,cbc,建图后每两个节点间均有两条双向边,这对于邻接表存储的图会存在很多冗余边. 解决方法:每个节点每位字符只能从原始字符往后枚举,即 枚举各字符串第一位的话 abc:bbc,cbc,dbc,... bbc:cbc,dbc,... cbc:

leetcode Word Ladder II

和上题 Word Ladder I题目差不多,不过这里是要记录所有最段路径的可能. 不同点在于,我们不能再BFS每层的时候把相距一个字符的字符串在dict中删除,因为hot -> hit 的话其他的例如 jit -> hit 就是hit可以出现在两条路径里头.所以不能立马删除.但是我们发现我们可以删除的是我们遍历完的每层的字符串,我们用known来存遍历完的层,unknown来存没有遍历的层,那么每次求得下一层unknown的时候,就首先把known里面有的从dic中删除. 主要思路还是和上一

LeetCode Word Ladder 找单词变换梯

题意:给出两个单词,以及一个set集合,当中是很多的单词.unordered_set是无序的集合,也就是说找的序列也是无序的了,是C++11的标准,可能得升级你的编译器版本了.要求找出一个从start到end这两个单词的变换序列.从start开始,每次可以变一个字母,且所变之后的单词必须在set中,最后要求变成end,问经过了多少个中间变换?注意要加多2次(start和end也要算),这是规定. 思路:广度搜索,以start为树根,一层一层扩展,直到找到end,返回数的深度即可.步骤是这样的,先

[python leetcode] Word Ladder II (very hard)[非常难,放弃]

Word Ladder II 描述 Given two words (start and end), and a dictionary, find all shortest transformation sequence(s) from start to end, such that: • Only one letter can be changed at a time • Each intermediate word must exist in the dictionary For examp

leetcode&mdash;&mdash;Word Ladder

    好多天没写leetcode了,就是卡在这题上,然后各种偷懒....之前思路一直没理顺,想了两个晚上,就放弃了,后来就去看答案去了...可是答案没有注释,有点看不太懂,后来只好上网查了,有的说用到trie树,就去看了trie树是啥...反正那段时间状态不好,总不想看,偶尔还被跑男吸引注意力,总之各种偷懒,到了今天终于看完答案了,试着结合各方答案写了一下..调了2个小时,终于通过了...而且效率也不高...但不管怎样,终于做出来了...但是不知道为什么这么做能保证每个单词的步骤数得出来的是最

leetcode Word Ladder 广搜

利用两个队列(或vector):curlevel和nextlvevl分别表示当前层的所有可能状态和转换到的下一层的所有可能状态.我们的目标是转换到end单词即可,深搜会超时.使用广搜,各层的可能结点同时向下进行,找到end即可return.当找完当前层的所有可能结点后,当前层也就空了,然后swap(当前层,下一层)循环向下搜索. 下面两个代码都是用这个方法,第一个超时,使用第二段代码,对于每个结点,只需找25*len种下一个可能结点是否存在,第一段代码需要在大数据里慢慢找. note:在一个字符

[LeetCode] Word Ladder

Well, this problem has a nice BFS structure. Let's see the example in the problem statement. start = "hit" end = "cog" dict = ["hot", "dot", "dog", "lot", "log"] Since only one letter c